char ecalloc_c_rcs_id [] =
	"$Id: ecalloc.c,v 1.1 1997/03/31 20:45:04 hjp Exp $";
/*
 * ecalloc -- wrapper function for calloc.
 *		aborts with error message if calloc fails.
 *
 */
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <ant/alloc.h>
#include <ant/io.h>
#include <ant/globals.h>

void *ecalloc (
	size_t nmemb,
	size_t size
){
	void	*new;

	if (nmemb * size / size != nmemb) {
		eprintf ("%s: cannot calloc %lu * %lu bytes: %s\n",
			 cmnd, (long)nmemb, (long)size, "arithmetic overflow");
		exit (1);
	}
	if ((new = calloc (nmemb, size)) == NULL) {
		eprintf ("%s: cannot calloc %lu * %lu bytes: %s\n",
			 cmnd, (long)nmemb, (long)size, strerror (errno));
		exit (1);
	}
	if (noisy) {
		eprintf ("ecalloc: new = %p, nmemb = %lu, size = %lu\n", 
			 new, (unsigned long)nmemb, (unsigned long)size);
	}
	return new;
}
