char efdopen_c_rcs_id [] = 
	"$Id: efdopen.c,v 1.2 1996/06/11 21:20:47 hjp Exp $";
/*
 * ``save'' version of fdopen.
 * Calls fdopen and, if it returns an error, prints an error message
 * and terminates program.
 *
 * $Log: efdopen.c,v $
 * Revision 1.2  1996/06/11 21:20:47  hjp
 * Added efregister
 * Added Configuration for Linux-ELF.
 *
 * Revision 1.1.1.1  1995/05/19  18:42:31  hjp
 * Imported from Minix. We'll see where main development will be ...
 *
 * Revision 1.1  1993/11/26  20:46:08  hjp
 * Initial revision
 *
 * Revision 1.2  1992/08/25  08:53:44  hp
 * fixed typo
 *
 * Revision 1.1  1992/06/26  12:51:19  hp
 * Initial revision
 *
 */

#include <errno.h>
#include <stdlib.h>
#include <string.h>

#include <ant/globals.h>
#include <ant/io.h>

	FILE *
efdopen (
	int fd,
	char const *mode
){
	FILE	*fp;
	char pseudofilename[4 + sizeof(int) * CHAR_BIT / 3 + 1 + 1];

	if ((fp = fdopen (fd, mode)) == NULL) {
		eprintf ("%s: cannot open file descriptor %d with mode \"%s\": %s\n",
			 cmnd, fd, mode, strerror (errno));
		exit (1);
	}
	sprintf (pseudofilename, "[fd %d]", fd);
	efregister(fp, pseudofilename);
	return fp;
}
