char efopen_c_rcs_id [] = 
	"$Id: efopen.c,v 1.2 1996/06/11 21:20:47 hjp Exp $";
/*
 * ``save'' version of fopen.
 * Calls fopen and, if it returns an error, prints an error message
 * and terminates program.
 *
 * $Log: efopen.c,v $
 * Revision 1.2  1996/06/11 21:20:47  hjp
 * Added efregister
 * Added Configuration for Linux-ELF.
 *
 * Revision 1.1.1.1  1995/05/19  18:42:31  hjp
 * Imported from Minix. We'll see where main development will be ...
 *
 * Revision 1.2  1992/05/05  01:56:41  hjp
 * Added a $ to rcsid
 *
 * Revision 1.1  1992/05/05  01:55:14  hjp
 * Initial revision
 *
 */

#include <errno.h>
#include <stdlib.h>
#include <string.h>

#include <ant/globals.h>
#include <ant/io.h>

	FILE *
efopen (
	char const *filename,
	char const *mode
){
	FILE	*fp;

	if ((fp = fopen (filename, mode)) == NULL) {
		eprintf ("%s: cannot open file \"%s\" with mode \"%s\": %s\n",
			 cmnd, filename, mode, strerror (errno));
		exit (1);
	}
	efregister(fp, filename);
	return fp;
}
