char efprintf_c_rcs_id [] = 
	"$Id: efprintf.c,v 1.2 1996/06/11 21:20:47 hjp Exp $";
/*
 *	efprintf -- save version of fprintf. Prints an error message
 *		and terminates on error.
 *
 *	$Log: efprintf.c,v $
 *	Revision 1.2  1996/06/11 21:20:47  hjp
 *	Added efregister
 *	Added Configuration for Linux-ELF.
 *
 * Revision 1.1.1.1  1995/05/19  18:42:31  hjp
 * Imported from Minix. We'll see where main development will be ...
 *
 * Revision 1.1  1993/11/26  20:46:07  hjp
 * Initial revision
 *
 * Revision 1.2  1992/08/25  08:53:44  hp
 * fixed format parameter
 *
 * Revision 1.1  1992/06/26  13:56:03  hp
 * Initial revision
 *
 */
 
#include <errno.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ant/globals.h>
#include <ant/io.h>


void efprintf (FILE *fp, const char * fmt, ...)
{
	va_list ap;

	va_start (ap, fmt);
	if (vfprintf (fp, fmt, ap) < 0) {
		eprintf ("%s: efprintf: cannot write to file `%s': %s\n",
		         cmnd, efregister(fp, NULL), strerror (errno));
		exit (1);
	}
	va_end (ap);
}
