char eopen_c_rcs_id [] = 
	"$Id: eopen.c,v 1.1 1997/01/23 20:45:44 hjp Exp $";
/*
 * ``save'' version of open.
 * Calls open and, if it returns an error, prints an error message
 * and terminates program.
 *
 * $Log: eopen.c,v $
 * Revision 1.1  1997/01/23 20:45:44  hjp
 * Merged changes in two CVS repositories (outch!).
 *
 */

#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <fcntl.h>

#include <ant/globals.h>
#include <ant/io.h>

	int
eopen (
	char const *filename,
	int flags, 
        ...
){
	int    fd;
        mode_t mode = 0;

        if (flags & O_CREAT) {
                va_list ap;
                va_start(ap, flags);
                mode = va_arg(ap, mode_t);

                fd = open (filename, flags, mode);
                va_end(ap);
        } else {
                fd = open (filename, flags);
        }
	if (fd == -1) {
		eprintf ("%s: cannot open file \"%s\" with flags %o, mode %o: %s\n",
			 cmnd, filename, flags, mode, strerror (errno));
		exit (1);
	}
	efdregister(fd, filename);
	return fd;
}
