char erealloc_c_rcs_id [] = 
	"$Id: erealloc.c,v 1.1.1.1 1995/05/19 18:42:31 hjp Exp $";
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <ant/alloc.h>
#include <ant/io.h>
#include <ant/globals.h>

void *erealloc (
	void	*old, 
	size_t	newsize
	/* resizes the allocated block pointed to by old to newsize bytes,
	 * moving it if necessary. The new location of the block is returned.
	 * If reallocation is impossible, the function prints an error message
	 * and exits.
	 *
	 * If noisy is nonzero, debugging output is written to stderr.
	 */
){
	void	*new;

	if ((new = realloc (old, newsize)) == NULL) {
		eprintf ("%s: cannot realloc block at %lx to %lu bytes: %s\n",
			 cmnd, (long) old, (long) newsize, strerror (errno));
		exit (1);
	}
	if (noisy) {
		eprintf ("erealloc: old = %lx, new = %lx, newsize = %ld\n", 
			 (long) old, (long) new, (long) newsize);
	}
	return new;
}
