char	getnextline_c_rcs_id [] =
	"$Id: getnextlin.c,v 1.1.1.1 1995/05/19 18:42:31 hjp Exp $";
/*
 * $Log: getnextlin.c,v $
 * Revision 1.1.1.1  1995/05/19 18:42:31  hjp
 * Imported from Minix. We'll see where main development will be ...
 *
 * Revision 1.2  1992/12/17  00:35:20  hjp
 * adaped for Minix; added RCS id
 *
 */
#include <stdio.h>
#include <string.h>

#include <ant/string.h>
#include <ant/io.h>

#define SEP		" \t\n"
#define COMMENT_S	"#"
#define	FIELDMAX	32
#define BUFSIZE		512

/*
 *	public variables:
 *		fieldc contains the # of fields the line just read was split into.
 *		fieldv contains the fields.
 *
 *		Use them just like argc and argv in main.
 */

int fieldc;
char	* fieldv [FIELDMAX];

/*
 *	Private variables:
 *		buffer contains the line read by getnextline ().
 */

static char buffer [BUFSIZE];

/*
 *	getnextline
 *
 *	Reads next line from a file and split it into fields.
 *	fields are separated by white space.
 *	The result is delivered in the global variables fieldc and fieldv.
 *
 *	CAVEAT:
 *	+	lines longer than 511 characters are split into several
 *		lines, not necessarily at field boundaries.
 *	+	the maximum number of fields in a line is 31
 */

	bool
getnextline (
	FILE	* fp
){
	char	* p;

	if (fgets (buffer, BUFSIZE, fp) == NULL)
		return FALSE;
	for (fieldc = 0, p = nstrpar (buffer);
	     fieldc < FIELDMAX - 1 && p && ! STREQ (p, COMMENT_S);
	     fieldc ++, p = nstrpar (NULL)) {
		fieldv [fieldc] = p;
	}
	fieldv [fieldc] = NULL;
	return TRUE;
}
