char memmem_c_rcs_id [] =
	"$Id: memmem.c,v 1.1.1.1 1995/05/19 18:42:31 hjp Exp $";
/*
 * Function:	memmem
 * Purpose:	search for first occurrence of wanted in mem.
 * In:		mem	... pointer to memory area to be searched
 *		memsize ... size of    -"-
 *		wanted	... pointer to search pattern
 *		wantedsize ... size of -"-
 * Returns:	Pointer to first occurence or NULL if no match was
 *		found.
 * Bugs:	The search algorithm is rather primitive. Something
 *		like Boyer-Moore might speed up long searches
 *		considerably.
 *
 * $Log: memmem.c,v $
 * Revision 1.1.1.1  1995/05/19 18:42:31  hjp
 * Imported from Minix. We'll see where main development will be ...
 *
 * Revision 1.3  1994/04/22  01:19:15  hjp
 * fixed prototype of memmem
 *
 * Revision 1.2  1992/12/17  00:35:20  hjp
 * bug fix (void * arithmetic not allowed in ANSI C)
 *
 * Revision 1.1  1992/05/30  23:04:14  hjp
 * Initial revision
 *
 */

#include <string.h>
#include <ant/string.h>

void *memmem (
	const void *mem, size_t memsize,
	const void *wanted, size_t wantedsize
) {
	char	*p;

	if (wantedsize == 0) return (void *)mem;
	if (wantedsize > memsize) return NULL;
	memsize -= wantedsize - 1;

	while ((p = memchr (mem, *(unsigned char *)wanted, memsize))) {
		if (memcmp (p, wanted, wantedsize) == 0) return p;
		memsize -= p + 1 - (char *)mem;
		mem = p + 1;
	}
	return NULL;
}
