char rcsid_nstrncpy_c[] =
	"$Id: nstrncpy.c,v 1.1.1.1 1995/05/19 18:42:31 hjp Exp $";
/*
 * nstrncpy -- new style limited string copy
 *	Idea by Karl Heuer (I think)
 *
 *	Copy the zero-terminated string src to the character array starting
 *	at dst and ending just before limit. The resulting string is zero-terminated
 *	even if it was truncated. This is usually more useful than the
 *	behaviour of strncpy.
 *	Returns a pointer to the NUL character terminating dst.
 *
 *	$Log: nstrncpy.c,v $
 *	Revision 1.1.1.1  1995/05/19 18:42:31  hjp
 *	Imported from Minix. We'll see where main development will be ...
 *
 * Revision 1.3  1992/05/25  19:30:35  hjp
 * changed hjpstr.h to ant/string.h
 *
 * Revision 1.2  1992/04/04  00:10:08  hjp
 * Adapted to old compilers.
 * Fixed off-by-one error with truncated strings.
 *
 *
 *	1.0	91-08-23
 */

#include <ant/string.h>

	char *
nstrncpy (dst, src, limit)
	char * dst;
	char const * src;
        char const * limit;
{
	while ((dst < limit) && (* dst = * src)) {
		dst ++; src ++;
	}
        if (dst == limit) * -- dst = 0;
	return dst;
}
