char nstrpar_c_rcs_id [] = 
	"$Id: nstrpar.c,v 1.1.1.1 1995/05/19 18:42:31 hjp Exp $";
/*
 *	nstrpar
 *
 *	decompose string into parameters.
 *
 *	Parameters are strings delimited by white space or C-like strings.
 *
 *	NOTES:
 *		The closing quote of a quoted parameter is discarded.
 *		A string of the form ``"abc"def'' is decomposed into two
 *		parameters: ``"abc'' and ``def''.
 *
 *	BUGS:
 *		A string ending in \, where the last parameter starts with
 *		a quote will cause garbage to be returned as the last
 *		parameter and may corrupt data following string.
 *
 *	$Log: nstrpar.c,v $
 *	Revision 1.1.1.1  1995/05/19 18:42:31  hjp
 *	Imported from Minix. We'll see where main development will be ...
 *
 * Revision 1.2  1992/12/17  00:35:20  hjp
 * adapted for Minix; added RCS Id
 *
 */
#include <ctype.h>
#include <stddef.h>
#include <ant/string.h>

	char *
nstrpar (
	char * string
){
	static char *	lastpos;
	char *		startofpar;

	if (string) {
		lastpos = string;
	}
	while (isspace (* lastpos)) lastpos ++;
	if (* lastpos) {

		startofpar = lastpos;
		if (* lastpos == '"') {
			/* quoted parameters are converted from C string
			 * format to their `real' form on the fly
			 */

			char	* cp;	/* Where changes take place	*/
			int	c;

			lastpos ++;	/* skip initial quotes	*/
			for (cp = startofpar;
			     (c = parsechar (& lastpos)) != EOF;
			    cp ++) {
				* cp = c;
			}
			* cp = 0;
		} else {
			while (* lastpos && ! isspace (* lastpos)) lastpos ++;
		}
		if (* lastpos) {
			* lastpos ++ = 0;
		}
		return startofpar;
	} else {
		return NULL;
	}
}
