char parsechar_c_rcs_id [] =
	"$Id: parsechar.c,v 1.1.1.1 1995/05/19 18:42:31 hjp Exp $";
/*
 *	parsechar
 *	return character from a string in C syntax and advance pointer to
 *	next character.
 *
 *	Returns EOF if the end of the string ('"', '\n' or '\0') is
 *	encountered.
 *
 *	$Log: parsechar.c,v $
 *	Revision 1.1.1.1  1995/05/19 18:42:31  hjp
 *	Imported from Minix. We'll see where main development will be ...
 *
 * Revision 1.3  1992/12/15  23:26:50  hjp
 * copied from DOS to Minix
 *
 *
 *	1.2	90-11-03	hjp
 *		\' and \" added.
 *	1.1	90-09-05	hjp
 *		<ctype.h> included. (How could that ever have worked w/o??)
 *	1.0	90-08-15	hjp
 */


#include <ctype.h>
#include <ant/string.h>

int parsechar (
	char ** pp
){
	char 	* p = * pp;
	int	v;

	if (* p == '\n' || * p == '"' || * p == '\0') {
		return EOF;
	}
	if (* p == '\\') {
		if (isdigit (* ++ p)) {
			v = * p - '0';
			while (isdigit (* ++ p)) {
				v = v * 8 + * p - '0';
			}
		} else {
			switch (* p) {
			case 'n':
				v = '\n';
				break;
			case 'b':
				v = '\b';
				break;
			case 'f':
				v = '\f';
				break;
			case 'r':
				v = '\r';
				break;
			case 't':
				v = '\t';
				break;
			case '\\':
				v = '\\';
				break;
			case '\'':
				v = '\'';
				break;
			case '\"':
				v = '\"';
				break;
			case 'x':
				v = 0;
				while (isxdigit (* ++ p)) {
					v = v * 16 +
					    (* p > '9' ?
						toupper (*p)  - ('A' - 10):
						* p - '0'
					    );
				}
				p --;
				break;
			default:
				v = -2;
			}
			p ++;
                }
		* pp = p;
		return (unsigned char) v;
	} else {
		* pp = p + 1;
		return (unsigned char) * p;
	}
}
