char rdbootmonhdr_c_rcs_id [] = 
	"$Id: rdbootmonhdr.c,v 1.2 1995/05/19 19:35:00 hjp Exp $";

#include <stdio.h>

#include <a.out.h>
#if __minix
#include <util/image.h>
#endif

#include <ant/io.h>
#include "readheader.h"

exec_headerT *read_bootmon_header (FILE *fp) {
#if __minix
	/*
	 * read the header of a bootmon image.
	 *
	 * actually, bootmon images don't have any header, but
	 * their members have. So we check whether this looks
	 * like the a bootmon image member header, and if it 
	 * does, we seek back to where we started and return a
	 * header with only the type set.
	 */
	static 	exec_headerT	hdr;
	static	char		name [IM_NAME_MAX + 1];
	auto	int		i;
	auto	exec_headerT	*mnxhdr;
	auto	long		pos;


	pos = ftell (fp);
	if (fread (name, 1, sizeof (name), fp) != sizeof (name)) return NULL;

	/* The name should be padded with nul characters */
	if (name [IM_NAME_MAX] != '\0') return NULL;
	i = strlen (name);
	while (i < IM_NAME_MAX) {
		if (name [i] != '\0') return NULL;
		i ++;
	}

	/* This is followed by a normal Minix a.out header. */

	if (fgetc (fp) != MAGIC_MINIX0) return NULL;
	if (fgetc (fp) != MAGIC_MINIX1) return NULL;
	mnxhdr = read_minix_header (fp);

	if (! mnxhdr) return NULL;

	hdr = *mnxhdr;
	hdr.type = BOOTMON_IMAGE;
	hdr.name = name;

	fseek (fp, pos + 512, SEEK_SET);
	return &hdr;
#else
	/* other systems don't know about Minix bootmon images
	 */
	return NULL;
#endif
}
