char rdgnuhdr_c_rcs_id [] = 
	"$Id: rdgnuhdr.c,v 1.3 1997/01/23 20:45:48 hjp Exp $";

#include <assert.h>
#include <stdio.h>
#include <unistd.h>

#if __minix
#include <gnu.a.out.h>
#else
#include <a.out.h>
#endif

#include <ant/io.h>
#include "readheader.h"

#define GNU_SMAGIC	0xdeadbabe	/* see fs/exec.c */

exec_headerT *read_gnu_header (
	FILE *fp,
	exec_typeT type		/* type has already been determined
				 * by read_header
				 */
) {
	static 	exec_headerT	hdr;
	auto	long		(*readlong) (FILE *fp);
	auto	int		i;

	switch (hdr.type = type) {
	case GNU_LE_OBJ:
	case GNU_LE_PAGE:
	case GNU_LE_PURE:
		readlong = readlongle;
		break;
	case GNU_BE_OBJ:
	case GNU_BE_PAGE:
	case GNU_BE_PURE:
		readlong = readlongbe;
		break;
	default:
		assert (0);
	}
	if ((hdr.text = readlong (fp)) == EOF) return NULL;
	if ((hdr.data = readlong (fp)) == EOF) return NULL;
	if ((hdr.bss = readlong (fp)) == EOF) return NULL;
	if ((/* syms = */ readlong (fp)) == EOF) return NULL;
	if ((hdr.entry = readlong (fp)) == EOF) return NULL;
	if ((/* trsize = */ readlong (fp)) == EOF) return NULL;
	if ((/* drsize = */ readlong (fp)) == EOF) return NULL;
	hdr.total = hdr.text + hdr.data + hdr.bss;
	if (type == GNU_BE_PAGE || type == GNU_LE_PAGE) {
		if (readlong (fp) == GNU_SMAGIC) {
			hdr.total += readlong (fp);
		} else {
			readlong (fp);
			hdr.total += 0x10000;
		}
		for (i = 0; i < getpagesize (); i ++) {
			if (getc (fp) == EOF) return NULL;
		}
	} 

	return &hdr;
}
