char rdminixhdr_c_rcs_id [] = 
	"$Id: rdminixhdr.c,v 1.2 1995/05/19 19:35:01 hjp Exp $";

#include <stdio.h>

#include <a.out.h>

#include <ant/io.h>
#include "readheader.h"

exec_headerT *read_minix_header (FILE *fp) {
#if __minix
	auto	int		cpu, flags, hdrlen;
	static 	exec_headerT	hdr;
	auto	long		(*readlong) (FILE *fp);

	if ((flags = getc (fp)) == EOF) return NULL;
	if ((cpu = getc (fp)) == EOF) return NULL;
	switch (cpu) {
	case A_I8086:
		hdr.type = (flags & A_SEP) ? MINIX_I8086S_EXEC : MINIX_I8086C_EXEC;
		readlong = readlongle;
		break;
	case A_I80386:
		hdr.type = (flags & A_SEP) ? MINIX_I80386S_EXEC : MINIX_I80386C_EXEC;
		readlong = readlongle;
		break;
	case A_M68K:
		hdr.type = (flags & A_SEP) ? MINIX_M68000S_EXEC : MINIX_M68000C_EXEC;
		readlong = readlongbe;
		break;
	default:
		return NULL;
	}
	if ((hdrlen = getc (fp)) == EOF) return NULL;
	if (getc (fp) == EOF) return NULL;	/* reserved */
	if (getc (fp) == EOF) return NULL;	/* version stamp */
	if (getc (fp) == EOF) return NULL;
	if ((hdr.text = readlong (fp)) == EOF) return NULL;
	if ((hdr.data = readlong (fp)) == EOF) return NULL;
	if ((hdr.bss = readlong (fp)) == EOF) return NULL;
	if ((hdr.entry = readlong (fp)) == EOF) return NULL;
	if ((hdr.total = readlong (fp)) == EOF) return NULL;
	if (flags & A_SEP) hdr.total += hdr.text;
	fseek (fp, hdrlen - 28, SEEK_CUR);
	return &hdr;
#else
	/* Minix executables cannot be read on other systems for now.
	 */
	return NULL;
#endif
}
