#ifndef I_ant_readheader_h
#define I_ant_readheader_h
#if INCLUDE_IDENT
static char readheader_h_rcs_id [] =
	"$Id: readheader.h,v 1.1.1.1 1995/05/19 18:42:31 hjp Exp $";
#endif
/*
 * readheader -- functions to read the headers of various 
 *	binary files and the neccessary types and definitions
 *
 * $Log: readheader.h,v $
 * Revision 1.1.1.1  1995/05/19 18:42:31  hjp
 * Imported from Minix. We'll see where main development will be ...
 *
 * Revision 1.5  1994/03/26  23:49:01  hjp
 * added support for bootmon images
 *
 * Revision 1.4  1993/06/25  14:59:46  hjp
 * added entry to header struct
 *
 * Revision 1.3  1993/02/05  21:20:05  hjp
 * added rcs id and comment
 *
 */

#include <sys/types.h>

typedef struct exec_header exec_headerT;

enum exec_type {
	UNKNOWN,
	MINIX_I8086C_EXEC, MINIX_I80386C_EXEC, MINIX_M68000C_EXEC,
	MINIX_I8086S_EXEC, MINIX_I80386S_EXEC, MINIX_M68000S_EXEC,
	GNU_BE_PAGE, GNU_LE_PAGE,
	GNU_BE_PURE, GNU_LE_PURE,
	GNU_BE_OBJ, GNU_LE_OBJ,
	BCC_OBJ,
	BOOTMON_IMAGE,
	NR_TYPES
};
typedef enum exec_type exec_typeT;

extern char *exec_type_strings [NR_TYPES];

struct exec_header {
	exec_typeT type;
	unsigned long	text;		/* length of text segment */
	unsigned long	data;		/* length of data segment */
	unsigned long	bss;		/* length of bss segment */
	unsigned long	total;		/* total size of program in
					 * memory (including stack and
					 * heap
					 */
	off_t		textoff;	/* start of text segment in 
					 * file. If 0, text segment
					 * follows the header
					 */
	unsigned long	entry;		/* entry point */
	char		*name;		/* name of entry in 
					 * bootmon image or archive
					 */
	/* additional fields may be inserted */
};

/* need to redefine these here because I cannot include several 
 * a.out.h files
 */
#define	MAGIC_MINIX0		0x01
#define	MAGIC_MINIX1		0x03
#define	MAGIC_GNU_LE_PURE0	0x08
#define	MAGIC_GNU_LE_PURE1	0x01
#define	MAGIC_GNU_LE_PURE2	0x00
#define	MAGIC_GNU_LE_PURE3	0x00
#define	MAGIC_GNU_LE_OBJ0	0x07
#define	MAGIC_GNU_LE_OBJ1	0x01
#define	MAGIC_GNU_LE_OBJ2	0x00
#define	MAGIC_GNU_LE_OBJ3	0x00
#define	MAGIC_GNU_LE_PAGE0	0x0B
#define	MAGIC_GNU_LE_PAGE1	0x01
#define	MAGIC_GNU_LE_PAGE2	0x00
#define	MAGIC_GNU_LE_PAGE3	0x00
#define MAGIC_GNU_BE0		0x00
#define MAGIC_GNU_BE1		0x00
#define MAGIC_GNU_BE2		0x01
#define MAGIC_GNU_BE_PURE3	0x08
#define MAGIC_GNU_BE_OBJ3	0x07
#define MAGIC_GNU_BE_PAGE3	0x0D
#define	MAGIC_BCC0		0xa3
#define	MAGIC_BCC1		0x86

exec_headerT *read_exec_header (FILE *fp);
exec_headerT *read_minix_header (FILE *fp);
exec_headerT *read_bcc_header (FILE *fp);
exec_headerT *read_gnu_header (FILE *fp, exec_typeT type);
exec_headerT *read_bootmon_header (FILE *fp);
#endif /* I_ant_readheader_h */
