#ifndef I_ant_time_h
#define I_ant_time_h
/*
 * $Id: time.h,v 1.2 1997/01/23 20:45:49 hjp Exp $
 *
 * Time related functions from the ANT library
 *
 * $Log: time.h,v $
 * Revision 1.2  1997/01/23 20:45:49  hjp
 * Merged changes in two CVS repositories (outch!).
 *
 * Revision 1.1.1.1  1995/05/19  18:42:31  hjp
 * Imported from Minix. We'll see where main development will be ...
 *
 * Revision 1.2  1994/12/02  22:24:44  hjp
 * added timer functions
 *
 * Revision 1.1  1992/08/25  08:53:44  hp
 * Initial revision
 *
 */
#include <time.h>       /* for time_t */

/*
 * sleepus -- sleep us micro seconds
 */
void sleepus (long us);


/*
 * functions to measure real and cpu time. Many systems have system
 * calls with finer resolution than time and clock. These functions
 * are intended as a portable interface to those system calls.
 */
void resettimer (void);
void gettimer (double *real, double *cpu);

/* 
 * Return offset of local time zone in seconds. East of UTC is positive
 */
long gettzoff(time_t when);
#endif
