char writebin_c_rcs_id [] = 
	"$Id: writebin.c,v 1.1.1.1 1995/05/19 18:42:31 hjp Exp $";
/*
 * writebin -- functions to write binary files
 *
 * assumptions about data representation in files:
 *	Byte:	8 bits
 *	Short:	16 bits
 *	Long:	32 bits
 *	(i.e. the minimum sizes guarantueed by ANSI C)
 *
 * $Log: writebin.c,v $
 * Revision 1.1.1.1  1995/05/19 18:42:31  hjp
 * Imported from Minix. We'll see where main development will be ...
 *
 * Revision 1.1  1993/06/28  21:50:15  hjp
 * Initial revision
 *
 */

#include <stdio.h>
#include <ant/io.h>

int writeulongle (unsigned long v, FILE *fp) 
	/*
	 * Write an unsigned long value in little endian byte order
	 */
{
	putc (v & 255, fp);
	putc ((v >> 8) & 255, fp);
	putc ((v >> 16) & 255, fp);
	putc ((v >> 24) & 255, fp);
	return feof (fp) || ferror (fp) ? EOF : v;
}


int writeulongbe (unsigned long v, FILE *fp) 
	/*
	 * Write an unsigned long value in big endian byte order
	 */
{
	putc ((v >> 24) & 255, fp);
	putc ((v >> 16) & 255, fp);
	putc ((v >> 8) & 255, fp);
	putc (v & 255, fp);
	return feof (fp) || ferror (fp) ? EOF : v;
}


int writeushortle (unsigned short v, FILE *fp) 
	/*
	 * Write an unsigned short value in little endian byte order
	 */
{
	putc (v & 255, fp);
	putc ((v >> 8) & 255, fp);
	return feof (fp) || ferror (fp) ? EOF : v;
}


int writeushortbe (unsigned short v, FILE *fp) 
	/*
	 * Write an unsigned short value in big endian byte order
	 */
{
	putc ((v >> 8) & 255, fp);
	putc (v & 255, fp);
	return feof (fp) || ferror (fp) ? EOF : v;
}
